#ifndef CORE_BUFFER_H
#define CORE_BUFFER_H

#include <stddef.h>

typedef struct {
    size_t size;
    size_t capacity;
    char* buffer;
} CoreBuffer;

void coreInitBuffer(CoreBuffer* b);
void coreDestroyBuffer(CoreBuffer* b);
void coreAddSizedBufferData(CoreBuffer* b, const void* data, size_t size);
#define coreAddBufferData(buffer, data)                                        \
    coreAddSizedBufferData(buffer, data, sizeof(*data))
void coreClearBuffer(CoreBuffer* b);

#endif
