#include "core/Buffer.h"

#include <string.h>

#include "core/Utility.h"

void coreInitBuffer(CoreBuffer* b) {
    b->buffer = nullptr;
    b->capacity = 0;
    b->size = 0;
}

void coreDestroyBuffer(CoreBuffer* b) {
    coreFree(b->buffer);
    coreInitBuffer(b);
}

void coreAddSizedBufferData(CoreBuffer* b, const void* data, size_t size) {
    while(b->size + size >= b->capacity) {
        b->capacity = b->capacity == 0 ? 8 : (b->capacity * 5) / 4;
        b->buffer = coreReallocate(b->buffer, b->capacity);
    }
    memcpy(b->buffer + b->size, data, size);
    b->size += size;
}

void coreClearBuffer(CoreBuffer* b) {
    b->size = 0;
}
