#include "../Tests.h"
#include "core/Buffer.h"

static const size_t SIZE_TYPES =
    sizeof(int) + sizeof(long) + sizeof(float) + sizeof(double);

void testBuffer(bool light) {
    CoreBuffer buffer;
    coreInitBuffer(&buffer);
    size_t limit = light ? 1000 : 100000;
    for(size_t i = 0; i < limit; i++) {
        int a = 5;
        long b = 5l;
        float c = 5.0f;
        double d = 5.0;
        coreAddBufferData(&buffer, &a);
        coreAddBufferData(&buffer, &b);
        coreAddBufferData(&buffer, &c);
        coreAddBufferData(&buffer, &d);
    }
    CORE_TEST_SIZE(SIZE_TYPES * limit, buffer.size);

    coreClearBuffer(&buffer);
    long l = 20;
    coreAddBufferData(&buffer, &l);
    CORE_TEST_SIZE(sizeof(l), buffer.size);

    coreDestroyBuffer(&buffer);
}
